/*---------------------------------------------------*/
// tabler.js by Kamedo2. Parse ABC/HR for Java Results.
/*---------------------------------------------------*/
var fs = WScript.CreateObject("Scripting.FileSystemObject");
var br = unescape("%0D%0A");
var line = "";

function popup(str){
  WScript.CreateObject("WScript.Shell").Popup(str);
}

var error_suppress = 7;
function popup_error(str){
 if(error_suppress){
   popup(str);
   error_suppress--;
 }
}

function addspace(str,len){
 while(str.length<len)str += " ";
 return str;
}

/*---------------------------------------------------*/
//          Config,   change here. 
/*---------------------------------------------------*/
encoders = new Array(".16b48k.1.wav",".16b48k.2.wav",".16b48k.3.wav",".16b48k.4.wav",".16b48k.5.wav",".16b48k.6.wav");
original_exte = ".16b48k.wav";

encoder_name = new Array("Apple AAC","Opus 1.1","Ogg Vorbis","MP3 V5","FAAC 96k","FAAC q30");
score = new Array();
tracks_max = 40;
score_by_track = new Array(tracks_max);
score_by_track_by_listener = new Array();
comment_by_track_by_listener = new Array();
score_by_track_by_listener_name = new Array();
num_of_score_by_track_by_listener = new Array(tracks_max);
num_of_score_by_track = new Array(tracks_max);
for(var i=1;i<=tracks_max;i++){
 score_by_track[i] = new Array();
 score_by_track_by_listener[i] = new Array();
 comment_by_track_by_listener[i] = new Array();
 score_by_track_by_listener_name[i] = new Array();
 for(var j=0;j<encoders.length;j++){
  score_by_track[i][j] = 0.0; 
 }
 num_of_score_by_track[i] = 0;
}
score_by_listener = new Array();
num_of_score_by_listener = new Array();
var listener_num = 0;
var total_results_num = 0;





var stream3 = fs.CreateTextFile("tabler.txt");
var script_path = String(WScript.ScriptFullName).replace(WScript.ScriptName,"");
var the_path = fs.GetFolder(script_path);


var filename = "";
var variant = "";
var rate = "";
var stream;
var text = "";
var showresults_text = "";
var bylistener_text = "";
fld = new Enumerator(the_path.SubFolders);
for(; !fld.atEnd(); fld.moveNext()) {
 var folder_path = fld.item().Path
 if(folder_path.indexOf("_REJECTED_")!=-1)continue;
 listener_fld = fs.GetFolder(folder_path);
 var fc = new Enumerator(listener_fld.Files);
 var folder_name = folder_path.substring(folder_path.lastIndexOf("\\")+1,folder_path.length);
 text += folder_name+br;
 showresults_text += folder_name+br;
 score_by_listener[listener_num] = new Array();
 for(var i=0;i<encoders.length;i++){
  score_by_listener[listener_num][i] = 0;
 }
 num_of_score_by_listener[listener_num] = 0;
 for(; !fc.atEnd(); fc.moveNext()){
  filename = fc.item().Name;
  var logtype = 0;
  if(filename.substring(filename.length-4)==".txt" && filename.indexOf("invalid")==-1){
   stream = fs.OpenTextFile(fc.item().Path);
   if(!stream.AtEndOfStream){
    line = stream.ReadLine();
    if(line.indexOf("ABC/HR for Java")==0)logtype = 1;
   }
   stream.Close();
  }
  rateList = new Array();
  commentList = new Array();
  for(var i=0;i<encoders.length;i++){
   rateList[i] = 5;
   commentList[i] = "";
  }

  if(logtype==1){
   stream = fs.OpenTextFile(fc.item().Path);
   var comment_flag = false;
   while(!stream.AtEndOfStream){
    line = stream.ReadLine();
    if(line.match(/^----------------/)){
     comment_flag = false;
    }
    else if(comment_flag){
     commentList[variant] += " "+line;
    }
    else if(line.match(/^\d[RL] File: .+/)){
     variant = -1;
     for(var i=0;i<encoders.length;i++){
      if(line.substring(line.length-encoders[i].length,line.length)==encoders[i])variant = i;
     }
     if(variant==-1 && line.substring(line.length-original_exte.length,line.length)!=original_exte){
      popup_error(line+"\n\n"+filename+"\n"+folder_name+"\n"+variant);
     }
    }
    else if(line.match(/^\d[RL] Rating: .+/)){
     rate = line.substring(11,14);
     if(variant>=0 && rateList[variant]!=5)popup_error(line+"\n\n"+filename+"\n"+folder_name+"\nrateList["+variant+"] = "+rateList[variant]);
     if(variant>=0)rateList[variant] = rate-0;
    }
    else if(line.match(/^\d[RL] Comment: /)){
     if(variant>=0)commentList[variant] = line.substring(12,line.length);
     comment_flag = true;
    }
    else if(line.match(/[Tt]estname: ([Ss][am][ma]ple|[Tt]rack)\d+/)){
     if(line.charAt(14)=="l")variantSong = line.substring(16,line.length)-0;
     if(line.charAt(14)=="k")variantSong = line.substring(15,line.length)-0;
    }
    else if(line.match(/^ABX Results:/)){
     break;
    }
   }
   stream.Close();
   showresults_text += variantSong+" ";
   var track_num = Math.round(variantSong-0);
   score_by_track_by_listener[track_num][num_of_score_by_track[track_num]] = new Array();
   comment_by_track_by_listener[track_num][num_of_score_by_track[track_num]] = new Array();
   score_by_track_by_listener_name[track_num][num_of_score_by_track[track_num]] = folder_name;
   if(!isNaN(track_num) && track_num>0 && track_num<=tracks_max){
    for(var i=0;i<encoders.length;i++){
     score_by_track[track_num][i] += rateList[i];
     score_by_listener[listener_num][i] += rateList[i];
     score_by_track_by_listener[track_num][num_of_score_by_track[track_num]][i] = rateList[i];
     comment_by_track_by_listener[track_num][num_of_score_by_track[track_num]][i] = commentList[i];
     text += (rateList[i]+0.0000001).toFixed(1) + " ";
    }
    num_of_score_by_track[track_num]++;
    num_of_score_by_listener[listener_num]++; 
    total_results_num++;
   }
   text += variantSong;
   text += br;
  }
 }
 showresults_text += br;

 for(var i=0;i<encoders.length;i++){
  bylistener_text += (score_by_listener[listener_num][i]/num_of_score_by_listener[listener_num]+0.0000001).toFixed(3) + "\t";
 }
 bylistener_text += num_of_score_by_listener[listener_num] + "\t" + folder_name + br;
 text += br;
 listener_num++;
}

var by_track_text = encoder_name.join("\t")+br;
var score_by_track_by_listener_text = "";
for(var j=1;j<=tracks_max;j++){
 for(var i=0;i<encoders.length;i++){
  by_track_text += (score_by_track[j][i]/num_of_score_by_track[j]+0.0000001).toFixed(3) + "\t";
 }
 by_track_text += br;
 score_by_track_by_listener_text += br+br;
 score_by_track_by_listener_text += '<div>'+br;
 score_by_track_by_listener_text += '  <h3>Track '+j+' scores and comments</h3>'+br;
 score_by_track_by_listener_text += '  <p class="plotholder"><img src="canvas'+j+'.png"></p>'+br;
 score_by_track_by_listener_text += '  <p class="tableholder"><img src="canvas'+j+'t.png"></p>'+br;
 /*score_by_track_by_listener_text += encoder_name.join("\t")+br;
 for(var i=0;i<num_of_score_by_track[j];i++){
  for(var k=0;k<encoders.length;k++){
   score_by_track_by_listener_text += (score_by_track_by_listener[j][i][k]+0.0000001).toFixed(3) + "\t";
  }
  score_by_track_by_listener_text += br;
 }
 for(var i=0;i<num_of_score_by_track[j];i++){
  score_by_track_by_listener_text += "%samples\t"+score_by_track_by_listener_name[j][i] + br;
 }*/
 for(var k=0;k<Math.min(4,encoders.length);k++){
  var has_comment = false;
  for(var i=0;i<num_of_score_by_track[j];i++){
   if(comment_by_track_by_listener[j][i][k]!="")has_comment = true;
  }
  if(has_comment){
   score_by_track_by_listener_text += " <h3>"+encoder_name[k]+"</h3>"+br+"  <dl>"+br;
   for(var i=0;i<num_of_score_by_track[j];i++){
    if(comment_by_track_by_listener[j][i][k]!=""){
     score_by_track_by_listener_text += "  <dt>"+score_by_track_by_listener_name[j][i]+"</dt>"+br;
     score_by_track_by_listener_text += '  <dd><span class="score">'+score_by_track_by_listener[j][i][k]+"</span> "+comment_by_track_by_listener[j][i][k]+"</dd>"+br;
    }
   }
   score_by_track_by_listener_text += "  </dl>"+br;
  }
 }
 score_by_track_by_listener_text += '</div>';

 score_by_track_by_listener_text += br+br;
}

var summary = "tabler.js, with "+listener_num+" listeners and "+total_results_num+" results";


stream3.write(by_track_text);
stream3.write(br+br+br);
stream3.write(text);
stream3.write(br+br+br);
stream3.write(showresults_text);
stream3.write(br+br+br);
stream3.write(bylistener_text);
stream3.write(br+br+br);
stream3.write(score_by_track_by_listener_text);
stream3.write(br+br+br);
stream3.write(summary);
stream3.write(br+br+br);
popup("Finished "+summary);
WScript.Quit();

